#include <amxmod.inc>  
#include <xtrafun> 
#include <superheromod.inc>
#define TE_BEAMPOINTS 0
#define TE_EXPLOSION 3
#define TE_EXPLOSION2 12
new gHeroName[]="Storm"
new bool:gHasStormPowers[SH_MAXSLOTS+1]
new gStormTimer[SH_MAXSLOTS+1]
new lightning,Fire

public plugin_init()
{
  register_plugin("SUPERHERO Storm","1.0","[FTW]-S.W.A.T") 
  if ( isDebugOn() ) server_print("Attempting to create Storm Hero")
  register_cvar("Storm_level", "10" ) 
  shCreateHero(gHeroName, "Storm", "Creates Thunderstorms BEWARE MAY EVEN HILL YOURSELF", true, "Storm_level" )
  register_srvcmd("Storm_init", "Storm_init") 
  shRegHeroInit(gHeroName, "Storm_init") 
  register_srvcmd("Storm_kd",   "Storm_kd") 
  shRegKeyDown(gHeroName, "Storm_kd") 
  register_event("ResetHUD","newRound","b")
  register_srvcmd("Storm_loop", "Storm_loop")
  register_event("DeathMsg", "Storm_death", "a")
  set_task(1.0,"Storm_loop",0,"",0,"b" )
  register_cvar("storm_cooldown", "30" )
  register_cvar("storm_time", "15")
  register_cvar("storm_radius", "200")
  register_cvar("storm_maxdamage", "15")
} 
public plugin_precache() 
{ 
   lightning = precache_model("sprites/lgtning.spr") 
   Fire = precache_model("sprites/zerogxplode.spr") 
} 
public Storm_init()
{
  new temp[6]
  read_argv(1,temp,5) 
  new id=str_to_num(temp) 
  read_argv(2,temp,5) 
  new hasPowers=str_to_num(temp) 
  gHasStormPowers[id]=(hasPowers!=0) 
  if ( !hasPowers  && is_user_connected(id) )
  {
   remove_task(1,1)
  }
}
public newRound(id)
{
  gPlayerUltimateUsed[id]=false
  remove_task(1,1)
  return PLUGIN_HANDLED
}
public Storm_kd() { 
  new temp[6]
  read_argv(1,temp,5)
  new id=str_to_num(temp)  
  if ( gPlayerUltimateUsed[id] ) 
  {
    playSoundDenySelect(id) 
    return PLUGIN_HANDLED 
  }
  gStormTimer[id]=get_cvar_num("storm_time")+1
  new StormCooldown=get_cvar_num("storm_cooldown")
  if ( StormCooldown>0 )
	ultimateTimer(id, StormCooldown * 1.0 )
  new arg[32] 
  read_argv(1,arg,31) 
  if(arg[0] == '1') 
  { 
     set_task(1.0,"randomtime",0) 
  }   
  return PLUGIN_HANDLED 
} 
public lightningbolt(id)
{
	new players[32],inum
	new Float:origin[3]
	new porigin1[3],porigin2[3],forigin[3]
	get_players(players,inum)
	new victim = random_num(1,inum)
	new victim2 = random_num(1,inum)
	get_user_origin(victim,porigin1)
	get_user_origin(victim2,porigin2)
	forigin[0]=(porigin1[0]+porigin2[0])/2
	forigin[1]=(porigin1[1]+porigin2[1])/2
	forigin[2]=(porigin1[2]+porigin2[2])/2
	origin[0]=float(forigin[0]+random_num(1,500))
	origin[1]=float(forigin[1]+random_num(1,500))
	

	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
	write_byte(TE_BEAMPOINTS) 
	write_coord(floatround(origin[0])) 
	write_coord(floatround(origin[1])) 
	write_coord(floatround(origin[2])+1000000) 
	write_coord(floatround(origin[0])) 
	write_coord(floatround(origin[1])) 
	write_coord(floatround(origin[2])-20) 
	write_short(lightning)   // model 
	write_byte(1) // start frame 
	write_byte(20) // framerate 
	write_byte(6) // life 
	write_byte(500)  // width 
	write_byte(2)   // noise 
	write_byte(230)   // r, g, b 
	write_byte(230)   // r, g, b 
	write_byte(50)   // r, g, b 
	write_byte(1000)   // brightness 
	write_byte(2)      // speed 
	message_end()
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
	write_byte(TE_BEAMPOINTS) 
	write_coord(floatround(origin[0])-10) 
	write_coord(floatround(origin[1])-10) 
	write_coord(floatround(origin[2])+1000000) 
	write_coord(floatround(origin[0])) 
	write_coord(floatround(origin[1])) 
	write_coord(floatround(origin[2])-20) 
	write_short(lightning)   // model 
	write_byte(1) // start frame 
	write_byte(20) // framerate 
	write_byte(6) // life 
	write_byte(500)  // width 
	write_byte(2)   // noise 
	write_byte(230)   // r, g, b 
	write_byte(230)   // r, g, b 
	write_byte(50)   // r, g, b 
	write_byte(1000)   // brightness 
	write_byte(2)      // speed 
	message_end()
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
	write_byte(TE_BEAMPOINTS) 
	write_coord(floatround(origin[0])+10) 
	write_coord(floatround(origin[1])+10) 
	write_coord(floatround(origin[2])+1000000) 
	write_coord(floatround(origin[0])) 
	write_coord(floatround(origin[1])) 
	write_coord(floatround(origin[2])-20) 
	write_short(lightning)   // model 
	write_byte(1) // start frame 
	write_byte(20) // framerate 
	write_byte(6) // life 
	write_byte(500)  // width 
	write_byte(2)   // noise 
	write_byte(230)   // r, g, b 
	write_byte(230)   // r, g, b 
	write_byte(50)   // r, g, b 
	write_byte(1000)   // brightness 
	write_byte(2)      // speed 
	message_end()
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
	write_byte(TE_EXPLOSION)
	write_coord(floatround(origin[0])) 
	write_coord(floatround(origin[1])) 
	write_coord(floatround(origin[2]))
	write_short(Fire)
	write_byte(100)
	write_byte(50)
	write_byte(0)
	message_end()
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
	write_byte(TE_EXPLOSION)
	write_coord(floatround(origin[0])+50) 
	write_coord(floatround(origin[1])+50) 
	write_coord(floatround(origin[2]))
	write_short(Fire)
	write_byte(100)
	write_byte(100)
	write_byte(0)
	message_end()
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
	write_byte(TE_EXPLOSION)
	write_coord(floatround(origin[0])-50) 
	write_coord(floatround(origin[1])-50) 
	write_coord(floatround(origin[2]))
	write_short(Fire)
	write_byte(100)
	write_byte(150)
	write_byte(0)
	message_end()

	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)  
	write_byte(TE_EXPLOSION2)
	write_coord(floatround(origin[0])) 
	write_coord(floatround(origin[1])) 
	write_coord(floatround(origin[2])) 
	write_byte(188) // start color 
	write_byte(10) // num colors 
	message_end()
	RadiusDamage(id,forigin)
	return PLUGIN_HANDLED
}
public randomtime(id){
   set_task(3.0,"lightningbolt",1)
   set_task(0.1,"lightningbolt",1)
   set_task(random_num(1,4)*1.0,"randomtime",1)
}
public Storm_loop()
{
  for ( new id=1; id<=SH_MAXSLOTS; id++ )
  {
    if ( gHasStormPowers[id] && is_user_alive(id)  ) 
    {
      if ( gStormTimer[id]>0 )
      {
        gStormTimer[id]--
        new message[128]
        format(message, 127, "%d seconds until the storm will pass", gStormTimer[id] )
        set_hudmessage(255,0,0,-1.0,0.3,0,1.0,1.0,0.0,0.0,4)
        show_hudmessage( id, message)
      }
      else
      {
        if ( gStormTimer[id] == 0 )
        {
          remove_task(1,1)
        }
      }
    }
  }
}
public Storm_death()
{
  new id=read_data(2)
  if (gHasStormPowers[id]) 
  {
    if ( gStormTimer[id]>0 )
    {
      remove_task(1,1)
    }  
  }
  return PLUGIN_HANDLED 
}
public RadiusDamage(id,origin[3]) {
	new distanceBetween
	new damage, multiplier
	new FFOn= get_cvar_num("mp_friendlyfire")
	for(new vic = 1; vic <= SH_MAXSLOTS; vic++) 
	{ 
		if( is_user_alive(vic) && ( get_user_team(id) != get_user_team(vic) || FFOn != 0 || vic==id ) )
		{
			new origin1[3]
			get_user_origin(vic,origin1) 
			distanceBetween = get_distance(origin, origin1 )
			if( distanceBetween < get_cvar_num("storm_radius") )
			{
			multiplier=(get_cvar_num("storm_maxdamage")*get_cvar_num("storm_maxdamage"))/get_cvar_num("storm_radius")
			damage=(get_cvar_num("storm_radius")-distanceBetween)*multiplier
			damage=sqrt(damage)
			shExtraDamage(vic, id, damage, "Lightning")
			} // distance
		} // alive target...
	} // loop	
}